---
title: Generate Survey from PDF Document Using AI
product: Survey Creator
description: Learn how an AI-powered service integrated into Survey Creator can convert PDF forms into interactive web-based surveys. Upload a PDF document, let AI generate a survey, and refine the result as needed. Check out this JavaScript form builder demo to try it firsthand.
framework: Vanilla JS
source: https://surveyjs.io/survey-creator/examples/convert-pdf-to-web-survey-ai/vanillajs
index: https://surveyjs.io/survey-creator/examples/overview.md
---

# Generate Survey from PDF Document Using AI (Vanilla JS)

This demo shows how an AI-powered service integrated into Survey Creator can help users create dynamic surveys based on PDF forms. Click the **Upload PDF** button and select a PDF document that you want to convert. Please note that the process may take some time, and only the first two pages from the document will be converted to prevent server overload. After the conversion is finished, you can refine the survey as needed and preview the final result.

AI service integration starts with deploying a language model to your application and exposing an API for interaction with that model. Refer to tutorials dedicated to the model of your choice for instructions. This example uses the GPT-3.5 Turbo model deployed on the SurveyJS website.

A deployed AI model receives text prompts and responds with text completions. Your client-side code should construct the text prompts and send them to the model. For example, a prompt to generate a survey JSON schema based on a PDF document may look as shown below. Note the addition of the expected response format:

"Generate a SurveyJS JSON schema from the following pages: \n%PDF%\nReturn only an object in JSON format."

Once the AI service sends back a string with a survey JSON schema, assign it to Survey Creator's [`text`](/survey-creator/documentation/api-reference/survey-creator#text) property. Refer to the Code tab for a code example.

<!-- PREVIOUS INTRO: PDF forms play a big role in the document workflows of many organizations. They are reliable, easy to print and share, and widely supported across different operating systems. However, more and more businesses choose to migrate their PDF forms to modern web-based surveys and questionnaires, seeking enhanced interactivity, efficient data collection, and better compatibility with mobile devices.  -->

## Files

### `public/index.html`

```html
<!-- Uncomment the following lines to enable Ace Editor in the JSON Editor tab -->
<!-- 
<script src="https://unpkg.com/ace-builds/src-min-noconflict/ace.js"></script>
<script src="https://unpkg.com/ace-builds/src-min-noconflict/ext-searchbox.js"></script>
<script src="https://unpkg.com/ace-builds/src-min-noconflict/theme-clouds_midnight.js"></script>
-->

<div id="ai-load">
    <svg class="ai-loading-indicator">
        <use xlink:href="#icon-loading-48x48"></use>
    </svg>
</div>
<div id="surveyCreatorContainer" style="position: absolute; height: 100%; width: 100%"></div>
```

### `src/index.css`

```css
#ai-load {
    position: absolute;
    width: 100%;
    height: 100%;
    min-height: 480px;
    z-index: 200;
    background-color: rgb(128, 128, 128, 0.5);
    display: flex;
    align-items: center;
    justify-content: center;
    display: none;
}
.ai-loading-indicator {
    margin: auto;
    width: 48px;
    height: 48px;
    animation: rotation 1s infinite linear;
}

@keyframes rotation {
    from {
        transform: rotate(0deg);
    }

    to {
        transform: rotate(359deg);
    }
}
```

### `src/survey_json.js`

```js
export const surveyJSON = {
    "pages": [{
        "name": "page1",
        "elements": [{
            "type": "html",
            "name": "question1",
            "html": "Click the <b>Upload PDF</b> button and select a PDF form based on which you want to generate a survey."
        }]
    }]
};
```

### `src/index.js`

```js
import { SurveyCreator } from "survey-creator-js";
import "survey-core/survey.i18n";
import "survey-creator-core/survey-creator-core.i18n";
import { Action, ComputedUpdater } from "survey-core";
import { surveyJSON } from "./survey_json";
import "survey-core/survey-core.css";
import "survey-creator-core/survey-creator-core.css";
import "./index.css";
import SurveyTheme from "survey-core/themes";
import { registerCreatorTheme } from "survey-creator-core";

registerCreatorTheme(SurveyTheme); // Add predefined Survey Creator UI themes

const creator = new SurveyCreator();

function extractJsonStringFromAiResponse(raw) {
    if (raw == null || raw === "") return "";
    let s = String(raw).trim();
    if (s.startsWith("```")) {
        s = s.replace(/^```(?:json|javascript|js)?\r?\n?/i, "");
        const end = s.lastIndexOf("```");
        if (end >= 0) s = s.slice(0, end);
        return s.trim();
    }
    const embedded = s.match(/```(?:json|javascript|js)?\r?\n([\s\S]*?)```/i);
    if (embedded) return embedded[1].trim();
    return s;
}

function handleFileSelect(event) {
    const file = event.target.files[0];
    if (!file) return;

    const formData = new FormData();
    formData.append("file", file);
    formData.append("query", 'Generate SurveyJS JSON from the following pages: \n%PDF%\n Return only an object in JSON format.');
    document.getElementById("ai-load").style.display = "flex";
    fetch('/api/ai/pdf', {
        method: 'POST',
        body: formData
    })
    .then(response => response.json())
    .then(data => {
        if (!data.error) {
            const jsonText = extractJsonStringFromAiResponse(data.text);
            let isValid = true;
            try {
                const survey = new Survey.Model();
                survey.fromJSON(JSON.parse(jsonText), { validatePropertyValues: true });
                isValid = !survey.jsonErrors;
            } catch {
                isValid = false;
            }
            if (isValid) {
                creator.text = jsonText;
            } else {
                creator.notify("Generated JSON schema contains errors. Please fix them manually.", "error");
                creator.activeTab = "json";
                setTimeout(() => { creator.getPlugin("json").model.text = jsonText; }, 100)
            }
        } else {
            creator.notify(data.error, "error");
        }
    })
    .catch(error => creator.notify(error, "error"))
    .finally(() => {
        document.getElementById("ai-load").style.display = "none";
    });
}

const pdfToSurveyAction = new Action({
    id: "pdf-to-survey",
    title: "Upload PDF",
    iconName: "icon-folder-24x24",
    visible: new ComputedUpdater(() => creator.activeTab === "designer"),
    action: () => {
        const fileInput = document.createElement("input");
        fileInput.type = "file";
        fileInput.accept = ".pdf";
        fileInput.addEventListener('change', handleFileSelect);
        fileInput.click();
    }
});

// Add a custom button to the toolbar
creator.toolbar.actions.push(pdfToSurveyAction);

// Add a custom button to the bottom toolbar (visible only on mobile devices)
creator.footerToolbar.actions.push(pdfToSurveyAction);

creator.JSON = surveyJSON;
creator.render("surveyCreatorContainer");
```

### `package.json`

```json
{
  "dependencies": {
    "survey-core": "latest",
    "survey-js-ui": "latest",
    "survey-creator-core": "latest",
    "survey-creator-js": "latest"
  },
  "devDependencies": {
    "react-scripts": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/survey-creator/examples/convert-pdf-to-web-survey-ai/angular.md)
- [React](https://surveyjs.io/survey-creator/examples/convert-pdf-to-web-survey-ai/reactjs.md)
- [Vue 3](https://surveyjs.io/survey-creator/examples/convert-pdf-to-web-survey-ai/vue3js.md)
- [jQuery](https://surveyjs.io/survey-creator/examples/convert-pdf-to-web-survey-ai/jquery.md)


---
title: Generate Survey from PDF Document Using AI
product: Survey Creator
description: Learn how an AI-powered service integrated into Survey Creator can convert PDF forms into interactive web-based surveys. Upload a PDF document, let AI generate a survey, and refine the result as needed. Check out this JavaScript form builder demo to try it firsthand.
framework: Angular
source: https://surveyjs.io/survey-creator/examples/convert-pdf-to-web-survey-ai/angular
index: https://surveyjs.io/survey-creator/examples/overview.md
---

# Generate Survey from PDF Document Using AI (Angular)

This demo shows how an AI-powered service integrated into Survey Creator can help users create dynamic surveys based on PDF forms. Click the **Upload PDF** button and select a PDF document that you want to convert. Please note that the process may take some time, and only the first two pages from the document will be converted to prevent server overload. After the conversion is finished, you can refine the survey as needed and preview the final result.

AI service integration starts with deploying a language model to your application and exposing an API for interaction with that model. Refer to tutorials dedicated to the model of your choice for instructions. This example uses the GPT-3.5 Turbo model deployed on the SurveyJS website.

A deployed AI model receives text prompts and responds with text completions. Your client-side code should construct the text prompts and send them to the model. For example, a prompt to generate a survey JSON schema based on a PDF document may look as shown below. Note the addition of the expected response format:

"Generate a SurveyJS JSON schema from the following pages: \n%PDF%\nReturn only an object in JSON format."

Once the AI service sends back a string with a survey JSON schema, assign it to Survey Creator's [`text`](/survey-creator/documentation/api-reference/survey-creator#text) property. Refer to the Code tab for a code example.

<!-- PREVIOUS INTRO: PDF forms play a big role in the document workflows of many organizations. They are reliable, easy to print and share, and widely supported across different operating systems. However, more and more businesses choose to migrate their PDF forms to modern web-based surveys and questionnaires, seeking enhanced interactivity, efficient data collection, and better compatibility with mobile devices.  -->

## Files

### `src/app/components/creator.component.css`

```css
#ai-load {
    position: absolute;
    width: 100%;
    height: 100%;
    min-height: 480px;
    z-index: 200;
    background-color: rgb(128, 128, 128, 0.5);
    display: flex;
    align-items: center;
    justify-content: center;
    display: none;
}
.ai-loading-indicator {
    margin: auto;
    width: 48px;
    height: 48px;
    animation: rotation 1s infinite linear;
}

@keyframes rotation {
    from {
        transform: rotate(0deg);
    }

    to {
        transform: rotate(359deg);
    }
}
```

### `src/app/components/creator.component.html`

```html
<div style="position: fixed; top: 0; bottom: 0; right: 0; left: 0;">
    <survey-creator [model]="model"></survey-creator>
</div>
```

### `src/app/components/survey_json.js`

```js
export const surveyJSON = {
    "pages": [{
        "name": "page1",
        "elements": [{
            "type": "html",
            "name": "question1",
            "html": "Click the <b>Upload PDF</b> button and select a PDF form based on which you want to generate a survey."
        }]
    }]
};
```

### `src/app/components/creator.component.ts`

```ts
import { Component, OnInit } from "@angular/core";
import { SurveyCreatorModel } from "survey-creator-core";
import "survey-core/survey.i18n";
import "survey-creator-core/survey-creator-core.i18n";
import { Action, ComputedUpdater } from "survey-core";
import { surveyJSON } from "./survey_json";
import "survey-core/survey-core.css";
import "survey-creator-core/survey-creator-core.css";

import SurveyTheme from "survey-core/themes";
import { registerCreatorTheme } from "survey-creator-core";

registerCreatorTheme(SurveyTheme); // Add predefined Survey Creator UI themes

@Component({
    // tslint:disable-next-line:component-selector
    selector: "component-survey-creator",
    templateUrl: "./creator.component.html",
    styleUrls: ["./creator.component.css"]
})
export class SurveyCreatorComponent implements OnInit {
    model: SurveyCreatorModel;
    ngOnInit() {
        const creator = new SurveyCreatorModel();
        function extractJsonStringFromAiResponse(raw) {
            if (raw == null || raw === "") return "";
            let s = String(raw).trim();
            if (s.startsWith("```")) {
                s = s.replace(/^```(?:json|javascript|js)?\r?\n?/i, "");
                const end = s.lastIndexOf("```");
                if (end >= 0) s = s.slice(0, end);
                return s.trim();
            }
            const embedded = s.match(/```(?:json|javascript|js)?\r?\n([\s\S]*?)```/i);
            if (embedded) return embedded[1].trim();
            return s;
        }
        
        function handleFileSelect(event) {
            const file = event.target.files[0];
            if (!file) return;
        
            const formData = new FormData();
            formData.append("file", file);
            formData.append("query", 'Generate SurveyJS JSON from the following pages: \n%PDF%\n Return only an object in JSON format.');
            document.getElementById("ai-load").style.display = "flex";
            fetch('/api/ai/pdf', {
                method: 'POST',
                body: formData
            })
            .then(response => response.json())
            .then(data => {
                if (!data.error) {
                    const jsonText = extractJsonStringFromAiResponse(data.text);
                    let isValid = true;
                    try {
                        const survey = new Survey.Model();
                        survey.fromJSON(JSON.parse(jsonText), { validatePropertyValues: true });
                        isValid = !survey.jsonErrors;
                    } catch {
                        isValid = false;
                    }
                    if (isValid) {
                        creator.text = jsonText;
                    } else {
                        creator.notify("Generated JSON schema contains errors. Please fix them manually.", "error");
                        creator.activeTab = "json";
                        setTimeout(() => { creator.getPlugin("json").model.text = jsonText; }, 100)
                    }
                } else {
                    creator.notify(data.error, "error");
                }
            })
            .catch(error => creator.notify(error, "error"))
            .finally(() => {
                document.getElementById("ai-load").style.display = "none";
            });
        }
        
        const pdfToSurveyAction = new Action({
            id: "pdf-to-survey",
            title: "Upload PDF",
            iconName: "icon-folder-24x24",
            visible: new ComputedUpdater(() => creator.activeTab === "designer"),
            action: () => {
                const fileInput = document.createElement("input");
                fileInput.type = "file";
                fileInput.accept = ".pdf";
                fileInput.addEventListener('change', handleFileSelect);
                fileInput.click();
            }
        });
        
        // Add a custom button to the toolbar
        creator.toolbar.actions.push(pdfToSurveyAction);
        
        // Add a custom button to the bottom toolbar (visible only on mobile devices)
        creator.footerToolbar.actions.push(pdfToSurveyAction);
        
        creator.JSON = surveyJSON;
        this.model = creator;
    }
}
```

### `src/app/app.component.html`

```html
<component-survey-creator></component-survey-creator>
```

### `src/app/app.component.ts`

```ts
import { Component } from "@angular/core";

@Component({
    selector: "app-root",
    templateUrl: "./app.component.html"
})
export class AppComponent {
    title = "CodeSandbox";
}
```

### `src/app/app.module.ts`

```ts
import { BrowserModule } from "@angular/platform-browser";
import { NgModule } from "@angular/core";
import { AppComponent } from "./app.component";
import { SurveyCreatorModule } from "survey-creator-angular";
import { SurveyCreatorComponent } from "./components/creator.component";

@NgModule({
    declarations: [AppComponent, SurveyCreatorComponent],
    imports: [BrowserModule, SurveyCreatorModule],
    providers: [],
    bootstrap: [AppComponent]
})
export class AppModule { }
```

### `src/environments/environment.prod.ts`

```ts
export const environment = {
    production: true
};
```

### `src/environments/environment.ts`

```ts
// The file contents for the current environment will overwrite these during build.
// The build system defaults to the dev environment which uses `environment.ts`, but if you do
// `ng build --env=prod` then `environment.prod.ts` will be used instead.
// The list of which env maps to which file can be found in `.angular-cli.json`.

export const environment = {
    production: false
};
```

### `src/index.html`

```html
<div id="ai-load">
    <svg class="ai-loading-indicator">
        <use xlink:href="#icon-loading-48x48"></use>
    </svg>
</div>
<app-root></app-root>
```

### `src/main.ts`

```ts
import { enableProdMode } from "@angular/core";
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";

import { AppModule } from "./app/app.module";
import { environment } from "./environments/environment";

if (environment.production) {
    enableProdMode();
}

platformBrowserDynamic()
    .bootstrapModule(AppModule)
    .catch(err => console.log(err));
```

### `src/polyfills.ts`

```ts
/**
 * This file includes polyfills needed by Angular and is loaded before the app.
 * You can add your own extra polyfills to this file.
 *
 * This file is divided into 2 sections:
 *   1. Browser polyfills. These are applied before loading ZoneJS and are sorted by browsers.
 *   2. Application imports. Files imported after ZoneJS that should be loaded before your main
 *      file.
 *
 * The current setup is for so-called "evergreen" browsers; the last versions of browsers that
 * automatically update themselves. This includes Safari >= 10, Chrome >= 55 (including Opera),
 * Edge >= 13 on the desktop, and iOS 10 and Chrome on mobile.
 *
 * Learn more in https://angular.io/docs/ts/latest/guide/browser-support.html
 */

/***************************************************************************************************
 * BROWSER POLYFILLS
 */

/** IE9, IE10 and IE11 requires all of the following polyfills. **/
// import 'core-js/es6/symbol';
// import 'core-js/es6/object';
// import 'core-js/es6/function';
// import 'core-js/es6/parse-int';
// import 'core-js/es6/parse-float';
// import 'core-js/es6/number';
// import 'core-js/es6/math';
// import 'core-js/es6/string';
// import 'core-js/es6/date';
// import 'core-js/es6/array';
// import 'core-js/es6/regexp';
// import 'core-js/es6/map';
// import 'core-js/es6/weak-map';
// import 'core-js/es6/set';

/** IE10 and IE11 requires the following for NgClass support on SVG elements */
// import 'classlist.js';  // Run `npm install classlist.js`.

/** IE10 and IE11 requires the following for the Reflect API. */
// import 'core-js/es6/reflect';

/** Evergreen browsers require these. **/
// Used for reflect-metadata in JIT. If you use AOT (and only Angular decorators), you can remove.
import "core-js/proposals/reflect-metadata";

/**
 * Required to support Web Animations `@angular/platform-browser/animations`.
 * Needed for: All but Chrome, Firefox and Opera. http://caniuse.com/#feat=web-animation
 **/
// import 'web-animations-js';  // Run `npm install web-animations-js`.

/***************************************************************************************************
 * Zone JS is required by default for Angular itself.
 */
import "zone.js/dist/zone"; // Included with Angular CLI.

/***************************************************************************************************
 * APPLICATION IMPORTS
 */
```

### `src/styles.css`

```css
/* You can add global styles to this file and import other style files */
```

### `src/typings.d.ts`

```ts
/* SystemJS module definition */
declare var module: NodeModule;
interface NodeModule {
    id: string;
}
```

### `.angular-cli.json`

```json
{
  "apps": [
    {
      "root": "src",
      "outDir": "dist",
      "assets": [ "assets", "favicon.ico" ],
      "index": "index.html",
      "main": "main.ts",
      "polyfills": "polyfills.ts",
      "prefix": "app",
      "styles": [ "styles.css"  ],
      "scripts": [  ],
      "environmentSource": "environments/environment.ts",
      "environments": {
        "dev": "environments/environment.ts",
        "prod": "environments/environment.prod.ts"
      }
    }
  ]
}
```

### `_tsconfig.json`

```json
{
  "compileOnSave": false,
  "compilerOptions": {
    "baseUrl": "./",
    "outDir": "./dist/out-tsc",
    "sourceMap": true,
    "declaration": false,
    "allowSyntheticDefaultImports": true,
    "downlevelIteration": true,
    "experimentalDecorators": true,
    "moduleResolution": "node",
    "importHelpers": true,
    "resolveJsonModule": true,
    "target": "es2015",
    "module": "es2020",
    "lib": [
      "es2018",
      "dom"
    ]
  }
}
```

### `package.json`

```json
{
  "name": "surveyjs-angular",
  "scripts": {
    "ng": "ng",
    "start": "ng serve",
    "build": "ng build --prod",
    "test": "ng test",
    "lint": "ng lint",
    "e2e": "ng e2e"
  },
  "private": true,
  "dependencies": {
    "@angular/animations": "14.1.1",
    "@angular/cdk": "14.1.1",
    "@angular/common": "14.1.1",
    "@angular/compiler": "14.1.1",
    "@angular/core": "14.1.1",
    "@angular/forms": "14.1.1",
    "@angular/platform-browser": "14.1.1",
    "@angular/platform-browser-dynamic": "14.1.1",
    "@angular/router": "14.1.1",
    "core-js": "3.6.4",
    "rxjs": "6.5.4",
    "survey-angular-ui": "latest",
    "survey-creator-core": "latest",
    "survey-core": "latest",
    "survey-creator-angular": "latest",
    "tslib": "1.13.0",
    "zone.js": "0.11.7"
  },
  "devDependencies": {
    "@angular-devkit/build-angular": "~13.0.0",
    "@angular/cli": "~13.0.0",
    "@types/jasmine": "3.6.3",
    "@types/jasminewd2": "2.0.8",
    "@types/node": "14.14.28",
    "codelyzer": "6.0.1",
    "jasmine-core": "3.6.0",
    "jasmine-spec-reporter": "6.0.0",
    "karma": "6.1.1",
    "karma-chrome-launcher": "3.1.0",
    "karma-coverage-istanbul-reporter": "3.0.3",
    "karma-jasmine": "4.0.1",
    "karma-jasmine-html-reporter": "1.5.4",
    "protractor": "7.0.0",
    "ts-node": "9.1.1",
    "tslint": "~6.1.3",
    "typescript": "4.1.5"
  },
  "keywords": [ "angular", "surveyjs" ],
  "description": "SurveyJS-Angular example project"
}
```

## Other Frameworks

- [React](https://surveyjs.io/survey-creator/examples/convert-pdf-to-web-survey-ai/reactjs.md)
- [Vue 3](https://surveyjs.io/survey-creator/examples/convert-pdf-to-web-survey-ai/vue3js.md)
- [jQuery](https://surveyjs.io/survey-creator/examples/convert-pdf-to-web-survey-ai/jquery.md)
- [Vanilla JS](https://surveyjs.io/survey-creator/examples/convert-pdf-to-web-survey-ai/vanillajs.md)


---
title: Generate Survey from PDF Document Using AI
product: Survey Creator
description: Learn how an AI-powered service integrated into Survey Creator can convert PDF forms into interactive web-based surveys. Upload a PDF document, let AI generate a survey, and refine the result as needed. Check out this JavaScript form builder demo to try it firsthand.
framework: React
source: https://surveyjs.io/survey-creator/examples/convert-pdf-to-web-survey-ai/reactjs
index: https://surveyjs.io/survey-creator/examples/overview.md
---

# Generate Survey from PDF Document Using AI (React)

This demo shows how an AI-powered service integrated into Survey Creator can help users create dynamic surveys based on PDF forms. Click the **Upload PDF** button and select a PDF document that you want to convert. Please note that the process may take some time, and only the first two pages from the document will be converted to prevent server overload. After the conversion is finished, you can refine the survey as needed and preview the final result.

AI service integration starts with deploying a language model to your application and exposing an API for interaction with that model. Refer to tutorials dedicated to the model of your choice for instructions. This example uses the GPT-3.5 Turbo model deployed on the SurveyJS website.

A deployed AI model receives text prompts and responds with text completions. Your client-side code should construct the text prompts and send them to the model. For example, a prompt to generate a survey JSON schema based on a PDF document may look as shown below. Note the addition of the expected response format:

"Generate a SurveyJS JSON schema from the following pages: \n%PDF%\nReturn only an object in JSON format."

Once the AI service sends back a string with a survey JSON schema, assign it to Survey Creator's [`text`](/survey-creator/documentation/api-reference/survey-creator#text) property. Refer to the Code tab for a code example.

<!-- PREVIOUS INTRO: PDF forms play a big role in the document workflows of many organizations. They are reliable, easy to print and share, and widely supported across different operating systems. However, more and more businesses choose to migrate their PDF forms to modern web-based surveys and questionnaires, seeking enhanced interactivity, efficient data collection, and better compatibility with mobile devices.  -->

## Files

### `public/index.html`

```html
<!-- Uncomment the following lines to enable Ace Editor in the JSON Editor tab -->
<!-- 
<script src="https://unpkg.com/ace-builds/src-min-noconflict/ace.js"></script>
<script src="https://unpkg.com/ace-builds/src-min-noconflict/ext-searchbox.js"></script>
<script src="https://unpkg.com/ace-builds/src-min-noconflict/theme-clouds_midnight.js"></script>
-->

<div id="ai-load">
    <svg class="ai-loading-indicator">
        <use xlink:href="#icon-loading-48x48"></use>
    </svg>
</div>
<div id="surveyCreatorContainer" style="position: absolute; height: 100%; width: 100%"></div>
```

### `src/survey_json.js`

```js
export const surveyJSON = {
    "pages": [{
        "name": "page1",
        "elements": [{
            "type": "html",
            "name": "question1",
            "html": "Click the <b>Upload PDF</b> button and select a PDF form based on which you want to generate a survey."
        }]
    }]
};
```

### `src/SurveyCreatorComponent.jsx`

```js
import React from "react";
import { SurveyCreator, SurveyCreatorComponent } from "survey-creator-react";
import "survey-core/survey.i18n";
import "survey-creator-core/survey-creator-core.i18n";
import { Action, ComputedUpdater } from "survey-core";
import { surveyJSON } from "./survey_json";
import "survey-core/survey-core.css";
import "survey-creator-core/survey-creator-core.css";
import "./index.css";

import SurveyTheme from "survey-core/themes";
import { registerCreatorTheme } from "survey-creator-core";

registerCreatorTheme(SurveyTheme); // Add predefined Survey Creator UI themes

function SurveyCreatorRenderComponent() {
    const creator = new SurveyCreator();
    function extractJsonStringFromAiResponse(raw) {
        if (raw == null || raw === "") return "";
        let s = String(raw).trim();
        if (s.startsWith("```")) {
            s = s.replace(/^```(?:json|javascript|js)?\r?\n?/i, "");
            const end = s.lastIndexOf("```");
            if (end >= 0) s = s.slice(0, end);
            return s.trim();
        }
        const embedded = s.match(/```(?:json|javascript|js)?\r?\n([\s\S]*?)```/i);
        if (embedded) return embedded[1].trim();
        return s;
    }
    
    function handleFileSelect(event) {
        const file = event.target.files[0];
        if (!file) return;
    
        const formData = new FormData();
        formData.append("file", file);
        formData.append("query", 'Generate SurveyJS JSON from the following pages: \n%PDF%\n Return only an object in JSON format.');
        document.getElementById("ai-load").style.display = "flex";
        fetch('/api/ai/pdf', {
            method: 'POST',
            body: formData
        })
        .then(response => response.json())
        .then(data => {
            if (!data.error) {
                const jsonText = extractJsonStringFromAiResponse(data.text);
                let isValid = true;
                try {
                    const survey = new Survey.Model();
                    survey.fromJSON(JSON.parse(jsonText), { validatePropertyValues: true });
                    isValid = !survey.jsonErrors;
                } catch {
                    isValid = false;
                }
                if (isValid) {
                    creator.text = jsonText;
                } else {
                    creator.notify("Generated JSON schema contains errors. Please fix them manually.", "error");
                    creator.activeTab = "json";
                    setTimeout(() => { creator.getPlugin("json").model.text = jsonText; }, 100)
                }
            } else {
                creator.notify(data.error, "error");
            }
        })
        .catch(error => creator.notify(error, "error"))
        .finally(() => {
            document.getElementById("ai-load").style.display = "none";
        });
    }
    
    const pdfToSurveyAction = new Action({
        id: "pdf-to-survey",
        title: "Upload PDF",
        iconName: "icon-folder-24x24",
        visible: new ComputedUpdater(() => creator.activeTab === "designer"),
        action: () => {
            const fileInput = document.createElement("input");
            fileInput.type = "file";
            fileInput.accept = ".pdf";
            fileInput.addEventListener('change', handleFileSelect);
            fileInput.click();
        }
    });
    
    // Add a custom button to the toolbar
    creator.toolbar.actions.push(pdfToSurveyAction);
    
    // Add a custom button to the bottom toolbar (visible only on mobile devices)
    creator.footerToolbar.actions.push(pdfToSurveyAction);
    
    creator.JSON = surveyJSON;
    return (<SurveyCreatorComponent creator={creator} />);
}

export default SurveyCreatorRenderComponent;
```

### `src/index.css`

```css
#ai-load {
    position: absolute;
    width: 100%;
    height: 100%;
    min-height: 480px;
    z-index: 200;
    background-color: rgb(128, 128, 128, 0.5);
    display: flex;
    align-items: center;
    justify-content: center;
    display: none;
}
.ai-loading-indicator {
    margin: auto;
    width: 48px;
    height: 48px;
    animation: rotation 1s infinite linear;
}

@keyframes rotation {
    from {
        transform: rotate(0deg);
    }

    to {
        transform: rotate(359deg);
    }
}
```

### `src/index.js`

```js
import React from "react";
import { createRoot } from "react-dom/client";
import SurveyCreatorRenderComponent from "./SurveyCreatorComponent";

const root = createRoot(document.getElementById("surveyCreatorContainer"));
root.render(<SurveyCreatorRenderComponent />);
```

### `package.json`

```json
{
  "dependencies": {
    "react": "latest",
    "react-dom": "latest",
    "survey-core": "latest",
    "survey-react-ui": "latest",
    "survey-creator-core": "latest",
    "survey-creator-react": "latest"
  },
  "devDependencies": {
    "react-scripts": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/survey-creator/examples/convert-pdf-to-web-survey-ai/angular.md)
- [Vue 3](https://surveyjs.io/survey-creator/examples/convert-pdf-to-web-survey-ai/vue3js.md)
- [jQuery](https://surveyjs.io/survey-creator/examples/convert-pdf-to-web-survey-ai/jquery.md)
- [Vanilla JS](https://surveyjs.io/survey-creator/examples/convert-pdf-to-web-survey-ai/vanillajs.md)
